﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MultiSelect
{
    public partial class Form1 : Form
    {
        private DataTable table = null;

        public Form1()
        {
            InitializeComponent();
            this.grid.SelectionStrategyFilter = new SelectionStrategyFilter( this.grid );
            this.grid.DataSource = this.Table;
        }


        private DataTable Table
        {
            get
            {
                if ( this.table == null )
                {
                    this.table = new DataTable("table");
                    this.PopulateTable( this.table );
                }

                return this.table;
            }
        }

        private void PopulateTable( DataTable table )
        {
            table.Columns.Clear();
            table.Rows.Clear();

            table.Columns.Add( "String", typeof(string) );
            table.Columns.Add( "Number", typeof(int) );
            table.Columns.Add( "Date", typeof(DateTime) );

            table.Rows.Add( new object[]{ "One", 1, DateTime.Today } );
            table.Rows.Add( new object[]{ "Two", 2, DateTime.Today.AddDays(1) } );
            table.Rows.Add( new object[]{ "Three", 3, DateTime.Today.AddDays(2) } );
            table.Rows.Add( new object[]{ "Four", 4, DateTime.Today.AddDays(3) } );
        }
    }
}
